module Specification {

	function method sum (a:seq<int>, i:int, j:int) : int
    requires 0 <= i <= |a|
		requires 0 <= j <= |a|
    decreases j - i;
  {
    0	// Fill in the correct specification here
  }	
}

module Simple {
	import Specification

	/** [query(a, i, j)] returns the sum of elements in [a] between index [i] inclusive and index [j] exclusive */
	method query(a:array<int>, i:int, j:int) returns (res:int)
		requires 0 <= i <= a.Length
		requires 0 <= j <= a.Length
		ensures res == Specification.sum(a[..], i, j)
	{
		// Fill in an implementation that verifies
	}
}

module CumulativeArray {
	import Specification

	predicate is_cumulative_array_for(c:seq<int>, a:seq<int>)
	{
        |a| + 1 == |c| &&
		forall i :: 0 <= i < |c| ==> c[i] == Specification.sum(a, 0, i)
	}

    /** [construct(a)] returns the the cumulative sum array for a. */
  method construct(a:array<int>) returns (c:array<int>)
    ensures is_cumulative_array_for(c[..], a[..]);
  {
	  // Fill in an implementation that verifies
  }

	/** [query2(a, i, j)] returns the sum of elements in [a] between index [i] inclusive and index [j] exclusive */
	method query2(c:array<int>, i:int, j:int, ghost a:array<int>) returns (res:int)
		requires 0 <= i < c.Length
		requires 0 <= j < c.Length
		requires a.Length + 1 == c.Length
		requires is_cumulative_array_for(c[..], a[..])
		ensures res == Specification.sum(a[..],i,j)
	{
		// Fill in an implementation that verifies
	}

		/** [update(c, a, i, v)] updates cell [a[i]] to value [v] 
		 and updates the cumulative array [c] accordingly,
		 while touching a few cells of [c] as possible */
	method update (c:array<int>, a:array<int>, i:int, v:int)
    requires a != c;
		requires 0 <= i < a.Length
		requires a.Length + 1 == c.Length
		requires is_cumulative_array_for(c[..], a[..])
		modifies c, a
		// [a] is updated appropriately
		ensures a[i] == v
		ensures forall k:: 0 <= k < a.Length && k != i ==> a[k] == old(a)[k]
		// [c] is updated appropriately
		ensures is_cumulative_array_for(c[..], a[..])
	{
        // Fill in an implementation that verifies
	}
}

